/* (C) 2008 The Measurement Factory */

#include <libecap/common/errors.h>
#include <iostream>

libecap::TextException::TextException(const std::string &aMsg, const char *aFileName, int aLineNo):
	message(aMsg), theFileName(aFileName), theLineNo(aLineNo) {
}

libecap::TextException::~TextException() throw() {
	// can we do anything to prevent member destructors from throwing?
}

const char *libecap::TextException::what() const throw() {
	return message.c_str(); // XXX: add file:lineno
}


std::ostream &libecap::TextException::print(std::ostream &os) const {
	if (theFileName)
		os << theFileName << ':' << theLineNo << ": ";
	return os << message;
}

void libecap::Throw(const char *message, const char *fileName, int lineNo) {
	// the exception recepient should print the exception
	throw TextException(message, fileName, lineNo);
}
